# Class OjSunburst

The component WebElement for oj-sunburst. Do not instantiate this class directly, instead, use ojSunburst.

#### Hierarchy

- OjSunburstBase
  - OjSunburst

#####
Index

### Constructors

constructor

### Methods

changeHiddenCategories
changeHighlightedCategories
changeSelection
changeStartAngle
clear
click
doDrill
findElement
findElements
getAnimationDuration
getAnimationOnDataChange
getAnimationOnDisplay
getAnimationUpdateColor
getAs
getAttribute
getColorLabel
getCssValue
getDisplayLevels
getDrilling
getDriver
getHiddenCategories
getHighlightMatch
getHighlightMode
getHighlightedCategories
getHoverBehavior
getHoverBehaviorDelay
getId
getLocation
getNodeDefaults
getNodes
getProperty
getRect
getRootNode
getRootNodeContent
getRotation
getSelection
getSelectionMode
getShadowRoot
getSize
getSizeLabel
getSorting
getStartAngle
getTagName
getText
getTooltip
getTouchResponse
getTrackResize
getTranslations
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjSunburst(el, locators): OjSunburst

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjSunburst

  Inherited from OjSunburstBase.constructor

## Methods

### changeHiddenCategories

- changeHiddenCategories(hiddenCategories): Promise<void>

- Sets the value of `hiddenCategories` property. An array of category strings used for filtering. Nodes with any category matching an item in this array will be filtered.

  #### Parameters

  - ##### hiddenCategories: string[]

    The value to set for `hiddenCategories`

  #### Returns Promise<void>

  Inherited from OjSunburstBase.changeHiddenCategories

### changeHighlightedCategories

- changeHighlightedCategories(highlightedCategories): Promise<void>

- Sets the value of `highlightedCategories` property. An array of category strings used for highlighting. Nodes matching categories in this array will be highlighted.

  #### Parameters

  - ##### highlightedCategories: string[]

    The value to set for `highlightedCategories`

  #### Returns Promise<void>

  Inherited from OjSunburstBase.changeHighlightedCategories

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. An array containing the ids of the initially selected nodes.

  #### Parameters

  - ##### selection: any[]

    The value to set for `selection`

  #### Returns Promise<void>

  Inherited from OjSunburstBase.changeSelection

### changeStartAngle

- changeStartAngle(startAngle): Promise<void>

- Sets the value of `startAngle` property. Specifies the starting angle of the sunburst. Valid values are numbers between 0 and 360.

  #### Parameters

  - ##### startAngle: number

    The value to set for `startAngle`

  #### Returns Promise<void>

  Inherited from OjSunburstBase.changeStartAngle

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjSunburstBase.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjSunburstBase.click

### doDrill

- doDrill(nodeId): Promise<void>

- Dispatches drill event.

  #### Parameters

  - ##### nodeId: string

    Id of the new node to drill to. Only visible nodes and breadcrumbs are allowed. Any others will throw an exception.

  #### Returns Promise<void>

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  #### Inherit Doc

  Inherited from OjSunburstBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  #### Inherit Doc

  Inherited from OjSunburstBase.findElements

### getAnimationDuration

- getAnimationDuration(): Promise<number>

- Gets the value of `animationDuration` property. Specifies the animation duration in milliseconds. For data change animations with multiple stages, the value specifies the duration of each stage.

  #### Returns Promise<number>

  The value of `animationDuration` property.

  Inherited from OjSunburstBase.getAnimationDuration

### getAnimationOnDataChange

- getAnimationOnDataChange(): Promise<string>

- Gets the value of `animationOnDataChange` property. Specifies the animation that is applied on data changes.

  #### Returns Promise<string>

  The value of `animationOnDataChange` property.

  Inherited from OjSunburstBase.getAnimationOnDataChange

### getAnimationOnDisplay

- getAnimationOnDisplay(): Promise<string>

- Gets the value of `animationOnDisplay` property. Specifies the animation that is shown on initial display.

  #### Returns Promise<string>

  The value of `animationOnDisplay` property.

  Inherited from OjSunburstBase.getAnimationOnDisplay

### getAnimationUpdateColor

- getAnimationUpdateColor(): Promise<string>

- Gets the value of `animationUpdateColor` property. Specifies the color displayed during a data change animation when a node is updated.

  #### Returns Promise<string>

  The value of `animationUpdateColor` property.

  Inherited from OjSunburstBase.getAnimationUpdateColor

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. An alias for the '$current' context variable passed to slot content for the nodeTemplate slot.

  #### Returns Promise<string>

  The value of `as` property.

  #### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

  Inherited from OjSunburstBase.getAs

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjSunburstBase.getAttribute

### getColorLabel

- getColorLabel(): Promise<string>

- Gets the value of `colorLabel` property. Specifies the label displayed in the legend describing the color metric of the sunburst.

  #### Returns Promise<string>

  The value of `colorLabel` property.

  Inherited from OjSunburstBase.getColorLabel

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjSunburstBase.getCssValue

### getDisplayLevels

- getDisplayLevels(): Promise<number>

- Gets the value of `displayLevels` property. The number of levels of nodes to display. By default all nodes are displayed.

  #### Returns Promise<number>

  The value of `displayLevels` property.

  Inherited from OjSunburstBase.getDisplayLevels

### getDrilling

- getDrilling(): Promise<string>

- Gets the value of `drilling` property. Specifies whether drilling is enabled. Drillable nodes will show a pointer cursor on hover and fire ojBeforeDrill and ojDrill events on click (double click if selection is enabled). See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `drilling` property.

  Inherited from OjSunburstBase.getDrilling

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjSunburstBase.getDriver

### getHiddenCategories

- getHiddenCategories(): Promise<string[]>

- Gets the value of `hiddenCategories` property. An array of category strings used for filtering. Nodes with any category matching an item in this array will be filtered.

  #### Returns Promise<string[]>

  The value of `hiddenCategories` property.

  Inherited from OjSunburstBase.getHiddenCategories

### getHighlightMatch

- getHighlightMatch(): Promise<string>

- Gets the value of `highlightMatch` property. The matching condition for the highlightedCategories property. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `highlightMatch` property.

  Inherited from OjSunburstBase.getHighlightMatch

### getHighlightMode

- getHighlightMode(): Promise<string>

- Gets the value of `highlightMode` property. Specifies whether the highlight-mode should be by category or descendants.

  #### Returns Promise<string>

  The value of `highlightMode` property.

  Inherited from OjSunburstBase.getHighlightMode

### getHighlightedCategories

- getHighlightedCategories(): Promise<string[]>

- Gets the value of `highlightedCategories` property. An array of category strings used for highlighting. Nodes matching categories in this array will be highlighted.

  #### Returns Promise<string[]>

  The value of `highlightedCategories` property.

  Inherited from OjSunburstBase.getHighlightedCategories

### getHoverBehavior

- getHoverBehavior(): Promise<string>

- Gets the value of `hoverBehavior` property. Defines the behavior applied when hovering over the nodes.

  #### Returns Promise<string>

  The value of `hoverBehavior` property.

  Inherited from OjSunburstBase.getHoverBehavior

### getHoverBehaviorDelay

- getHoverBehaviorDelay(): Promise<number>

- Gets the value of `hoverBehaviorDelay` property. Specifies initial hover delay in milliseconds for highlighting nodes.

  #### Returns Promise<number>

  The value of `hoverBehaviorDelay` property.

  Inherited from OjSunburstBase.getHoverBehaviorDelay

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjSunburstBase.getId

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from OjSunburstBase.getLocation

### getNodeDefaults

- getNodeDefaults(): Promise<NodeDefaults>

- Gets the value of `nodeDefaults` property. An object defining default properties for the nodes. See the Help documentation for more information.

  #### Returns Promise<NodeDefaults>

  The value of `nodeDefaults` property.

  Inherited from OjSunburstBase.getNodeDefaults

### getNodes

- getNodes(): Promise<null | Nodes[]>

- Gets the value of `nodes` property. An array of objects defining the data for the nodes. Also accepts a Promise for deferred data rendering.

  #### Returns Promise<null | Nodes[]>

  The value of `nodes` property.

  Inherited from OjSunburstBase.getNodes

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjSunburstBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  #### Inherit Doc

  Inherited from OjSunburstBase.getRect

### getRootNode

- getRootNode(): Promise<any>

- Gets the value of `rootNode` property. The id of the root node. When specified, only the root node and children of the root will be displayed.

  #### Returns Promise<any>

  The value of `rootNode` property.

  Inherited from OjSunburstBase.getRootNode

### getRootNodeContent

- getRootNodeContent(): Promise<RootNodeContent>

- Gets the value of `rootNodeContent` property. An object defining custom root node content for the sunburst.

  #### Returns Promise<RootNodeContent>

  The value of `rootNodeContent` property.

  Inherited from OjSunburstBase.getRootNodeContent

### getRotation

- getRotation(): Promise<string>

- Gets the value of `rotation` property. Specifies whether client side rotation is enabled.

  #### Returns Promise<string>

  The value of `rotation` property.

  Inherited from OjSunburstBase.getRotation

### getSelection

- getSelection(): Promise<any[]>

- Gets the value of `selection` property. An array containing the ids of the initially selected nodes.

  #### Returns Promise<any[]>

  The value of `selection` property.

  Inherited from OjSunburstBase.getSelection

### getSelectionMode

- getSelectionMode(): Promise<string>

- Gets the value of `selectionMode` property. Specifies the selection behavior on the sunburst. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `selectionMode` property.

  Inherited from OjSunburstBase.getSelectionMode

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjSunburstBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  #### Inherit Doc

  Inherited from OjSunburstBase.getSize

### getSizeLabel

- getSizeLabel(): Promise<string>

- Gets the value of `sizeLabel` property. Specifies the label used in the legend describing the size metric of the sunburst.

  #### Returns Promise<string>

  The value of `sizeLabel` property.

  Inherited from OjSunburstBase.getSizeLabel

### getSorting

- getSorting(): Promise<string>

- Gets the value of `sorting` property. Specifies whether the nodes are sorted by size. Nodes with the same parent are sorted in order of descending size.

  #### Returns Promise<string>

  The value of `sorting` property.

  Inherited from OjSunburstBase.getSorting

### getStartAngle

- getStartAngle(): Promise<number>

- Gets the value of `startAngle` property. Specifies the starting angle of the sunburst. Valid values are numbers between 0 and 360.

  #### Returns Promise<number>

  The value of `startAngle` property.

  Inherited from OjSunburstBase.getStartAngle

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjSunburstBase.getTagName

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjSunburstBase.getText

### getTooltip

- getTooltip(): Promise<Tooltip>

- Gets the value of `tooltip` property. An object containing an optional callback function for tooltip customization.

  #### Returns Promise<Tooltip>

  The value of `tooltip` property.

  Inherited from OjSunburstBase.getTooltip

### getTouchResponse

- getTouchResponse(): Promise<string>

- Gets the value of `touchResponse` property. Specifies configuration options for touch and hold delays on mobile devices. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `touchResponse` property.

  Inherited from OjSunburstBase.getTouchResponse

### getTrackResize

- getTrackResize(): Promise<string>

- Gets the value of `trackResize` property. Defines whether the element will automatically render in response to changes in size. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `trackResize` property.

  Inherited from OjSunburstBase.getTrackResize

### getTranslations

- getTranslations(): Promise<null | Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<null | Translations>

  The value of `translations` property.

  Inherited from OjSunburstBase.getTranslations

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from OjSunburstBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from OjSunburstBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjSunburstBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjSunburstBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjSunburstBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjSunburstBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjSunburstBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjSunburstBase.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjSunburstBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjSunburstBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjSunburstBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjSunburstBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjSunburstBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjSunburstBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  #### Throws

  if the object is not a valid encoded ID.

  Inherited from OjSunburstBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjSunburstBase.isId

Generated using TypeDoc